/* F2_BlZu19.c                                                             */
/* Aufruf in: FUP Steuer-S-Funktion FUP_V30 fr Blcke ZA, ZE, ZX          */

void F2_BlZu19(u,y,nInputs)
     InputRealPtrsType   u;
     real_T             *y;
{
 short int  i, ii, j, VL, VL2, iSp;
 int        *ASP, *RSP, FN, BK;
 
 extern int *FUP_ZSP[];                             /* Zeiger-Adrespeicher */
 extern int STO_SCH;                          /* allgemeiner Fehlerspeicher */

if (*y==0)                                          /* Ausgang als Speicher */
   {/* falls *u[2]==0 dann *y=0 oder auch keine Reaktion - Block nicht aktiv*/
   if (*u[2]!=0 )     /* Block aktivieren + Rcksetzspeicher variabel laden */
      {*y=*u[1];                            /* eigene Blockkennung ausgeben */
       FN=*u[0];
       RSP=*(FUP_ZSP+3*(FN-1)+1);   /* zu FN gehrigen FUP_RSP Zeiger laden */
       VL=*(RSP-1);                         /* zugehrige Vektorlnge laden */
       for (ii=2; ii<nInputs; ii++)
           {BK=*u[ii];/* Blockkennung der sich rckzusetzenden Blcke laden */
            UNION_(VL,RSP,BK)     /* neue Vektorlnge NICHT rckgespeichert */
           }
       *(RSP-1)=VL;                           /* neue Vektorlnge speichern */
       BK=*u[1];                               /* eigene Blockkennung laden */
       ASP=*(FUP_ZSP+3*(FN-1));     /* zu FN gehrigen FUP_ASP Zeiger laden */
       VL2=*(ASP-1);                        /* zugehrige Vektorlnge laden */       
       UNION_(VL2,ASP,BK)         /* neue Vektorlnge NICHT rckgespeichert */
       *(ASP-1)=VL2;                          /* neue Vektorlnge speichern */
      }
   }
else
   {if (*u[2]==0 )                             /* Prfung auf Deaktivierung */
       {BK=*u[1];                              /* eigene Blockkennung laden */
        FN=*u[0];
        RSP=*(FUP_ZSP+3*(FN-1)+1);  /* zu FN gehrigen FUP_RSP Zeiger laden */
        VL=*(RSP-1);                        /* zugehrige Vektorlnge laden */
        ASP=*(FUP_ZSP+3*(FN-1));    /* zu FN gehrigen FUP_ASP Zeiger laden */
        VL2=*(ASP-1);                       /* zugehrige Vektorlnge laden */
        DEAKT_(VL,RSP,VL2,ASP,BK)      /* neue Vektorlngen rckgespeichert */
        if (j!=0)                      /* j wird in Makro DEAKT_ gesetzt!!! */
            *y=0;                              /* Deaktivierung ist erfolgt */
        else
            *y=*u[1];                                     /* zur Sicherheit */
       }
    else               /* Mehrfachaktivierung: vorheriges und nachfolgendes */
                             /* Ereignis fr einen Block schlieen sich aus */
       {FN=*u[0];
        RSP=*(FUP_ZSP+3*(FN-1)+1);  /* zu FN gehrigen FUP_RSP Zeiger laden */
        VL=*(RSP-1);                        /* zugehrige Vektorlnge laden */
        for (ii=2; ii<nInputs; ii++)
            {BK=*u[ii];/*Blockkennung der sich rckzusetzenden Blcke laden */
             UNION_(VL,RSP,BK)    /* neue Vektorlnge NICHT rckgespeichert */
            }
        *(RSP-1)=VL;            /* DEAKT_ speichert nur bei eigener Kennung */
        BK=*u[1];                              /* eigene Blockkennung laden */
        ASP=*(FUP_ZSP+3*(FN-1));    /* zu FN gehrigen FUP_ASP Zeiger laden */
        VL2=*(ASP-1);                       /* zugehrige Vektorlnge laden */
        DEAKT_(VL,RSP,VL2,ASP,BK)   /* FUP_RSP Zeiger und seine Lnge: s.o. */
        if (j!=0)                      /* j wird in Makro DEAKT_ gesetzt!!! */ 
            *y=0;                              /* Deaktivierung ist erfolgt */        
        else
            *y=*u[1];                                     /* zur Sicherheit */
       }
   }
}
