/* Aufruf von FUPI_FeZu5 in FUP Steuer-MEX-Funktion FUPI_V30 - Version 3.2 */
/* [VFB,BNsI]=FUPI_V30([BN FN],0,35) ---> Initialisierung fuer Bloecke ZF  */

#define  C_MEX_FUNCTION
#include "F2_FUPLIB30.h"

void FUPI_FeZu5(nlhs, nrhs, plhs, prhs)
     int            nlhs;
     int            nrhs;
     mxArray        *plhs[];
     const mxArray  *prhs[];
{
 char    *BNsI="General error state\nF1 X    ", Buf[4];
 double  *x, *y, *y2, BN, FN, fp; 
 int     i, VKS;
 
 extern int STO_SCH;            /* hier eigene Instanz von STO_SCH fuer FUPI */
                                                          /* Eingabepruefung */
 STOP_K((mxGetM(prhs[1])!=1)||(mxGetN(prhs[1])!=1)||
        (mxGetM(prhs[2])!=1)||(mxGetN(prhs[2])!=1),FT87,1);
 STOP_K(nlhs!=2,FT88,1);
 STOP_K((mxGetM(prhs[0])!=1)||(mxGetN(prhs[0])!=2),FT89,1);
  
 plhs[0]=mxCreateDoubleMatrix(1,2,mxREAL);
 y=mxGetPr(plhs[0]);
 plhs[1]=mxCreateDoubleMatrix(1,28,mxREAL);   /* z.Z. BN 4-stellig definiert */
 y2=mxGetPr(plhs[1]);
 x=mxGetPr(prhs[0]);

 modf(*x, &BN);                              /* ganze Zahl in BN schreiben   */
 fp=*x-BN;                                   /* Rest berechnen               */
 STOP_K(BN<BNRMIN||BN>BNRMAX||fp!=0,FT73,1); /* im Bereich ? UND Rest==0 ?   */
 modf(*(x+1), &FN);                          /* ganze Zahl in FN schreiben   */
 fp=*(x+1)-FN;                               /* Rest berechnen               */
 STOP_K(FN<FNRMIN||FN>FNRMAX||fp!=0,FT74,1); /* im Bereich ? UND Rest==0 ?   */
 if (STO_SCH==0)
    {_gcvt(BN,4,Buf);                        /*  alt: gcvt(BN,4,*(y2+4))     */
     if (BN>999) {VKS=4;} else if (BN>99&&BN<1000) {VKS=3;} /* Anz. Vorkost.?*/
     else if (BN>9&&BN<100) {VKS=2;} else {VKS=1;}
     for (i=0; i<24;  i++) {*(y2+i)   =*(BNsI+i);}/* alt:mit gcvt i<23 nur   */
     for (i=0; i<VKS; i++) {*(y2+i+24)=*(Buf+i);} /* zusaetzlich bei 64 Bit  */
     *(y2+21)=FN+48;           /* Zaehlung von Null aus UND wrzl ein Zeichen */
    }
 *y=FN; 
 *(y+1)=10*BN+FN;
}
                 