/* Aufruf von FUPI_X0BlZu6 in FUP Steuer-MEX-Funktion FUPI_V30               */
/* [VFB,BNsI]=FUPI_V30([BN FN],0,10) ---> Initialisierung fuer Bloecke ZA    */

#define  C_MEX_FUNCTION
#include "F2_FUPLIB30.h"

void FUPI_X0BlZu6(nlhs, nrhs, plhs, prhs)
     int            nlhs;
     int            nrhs;
     mxArray        *plhs[];
     const mxArray  *prhs[];
{
 char    *BNsI="F1 X    ";
 double  *x, *y, *y2, BN, FN, fp; 
 int     i;

 extern int STO_SCH;           /* hier eigene Instanz von STO_SCH fuer FUPI */
                                                         /* Eingabepruefung */
 
 STOP_K((mxGetM(prhs[1])!=1)||(mxGetN(prhs[1])!=1)||
        (mxGetM(prhs[2])!=1)||(mxGetN(prhs[2])!=1),FT70,1);
 STOP_K(nlhs!=2,FT71,1);
 STOP_K((mxGetM(prhs[0])!=1)||(mxGetN(prhs[0])!=2),FT72,1);  
 
 plhs[0]=mxCreateDoubleMatrix(1,2,mxREAL);
 y=mxGetPr(plhs[0]);
 plhs[1]=mxCreateDoubleMatrix(1,8,mxREAL);   /* z.Z. BN 4-stellig definiert */
 y2=mxGetPr(plhs[1]);
 x=mxGetPr(prhs[0]);
 
 modf(*x, &BN);                                /* ganze Zahl in BN schreiben */
 fp=*x-BN;                     /* LINUX: nicht fp als modf-Ausgang definieren*/
 STOP_K(BN<BNRMIN||BN>BNRMAX||fp!=0,FT73,1);
 modf(*(x+1), &FN);                            /* ganze Zahl in FN schreiben */
 fp=*(x+1)-FN;                 /* LINUX: nicht fp als modf-Ausgang definieren*/
 STOP_K(FN<FNRMIN||FN>FNRMAX||fp!=0,FT74,1);
 *(y+1)=10*BN+FN;
 if (STO_SCH==0)
    {gcvt(BN,4,*(y2+4));
     for (i=0; i<4; i++) {*(y2+i)=*(BNsI+i);}
     *(y2+1)=FN+48;            /* Zaehlung von Null aus UND wrzl ein Zeichen */
    }
 *y=FN;
}
