/* Aufruf von FUPI_FVZ4 in FUP Steuer-MEX-Funktion FUPI_V30                */
/* [BGK,VZG]=FUPI_V30(FN,BG+0,30) ---> Initialisierung fr Blcke FVZ      */

#define  C_MEX_FUNCTION
#include "F2_FUPLIB30.h"

void FUPI_FVZ4(nlhs, nrhs, plhs, prhs)
     int            nlhs;
     int            nrhs;
     mxArray        *plhs[];
     const mxArray  *prhs[];
{
 char    *VZG="Vorzustand von F1=\\n", z1[KBGMAX];
 double  *x, *y, *y2, FN, fp; 
 int     c, i, j=0, BGL, BGKL=1, ZS;
 int     ST=0;
          /* Beginn:0, Ziffern>0:1, Minus:2, Verknpfung:3, X:4, Ziffer0:5 */
 
 extern int STO_SCH;           /* hier eigene Instanz von STO_SCH fr FUPI */
                                                         /* Eingabeprfung */
 STOP_K((mxGetM(prhs[2])!=1)||(mxGetN(prhs[2])!=1),FT93,1);
 STOP_K(nlhs!=2,FT94,1);
 BGL=mxGetN(prhs[1]);
 STOP_K((mxGetM(prhs[0])!=1)||(mxGetN(prhs[0])!=1)||
                             ((mxGetM(prhs[1])!=1)&&(BGL>0)),FT95,1);
  
 x=mxGetPr(prhs[0]);
 fp=modf(*x, &FN);                                   /* Eingang 1 ist FN   */
 STOP_K(FN<FNRMIN||FN>FNRMAX||fp!=0,FT96,1);
 x=mxGetPr(prhs[1]);                                 /* Eingang 2 ist BG   */
 STOP_K(BGL==0,FT97,1);

 for (i=0; ((i<BGL)&&(j<KBGMAX-3)); i++)
                                   /* ungnstigster Fall: Abbruch bei ODER */
     {c=*(x+i);
      switch(c)                            /* Umkodierung der Zeichenkette */
           {case '0': *(z1+j)=*(x+i); j++;
                      STOP_K(ST!=1&&ST!=5,FT92,1);
                      ST=5; break;
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9': *(z1+j)=*(x+i); j++; ST=1; break;
            case ' ': break;
            case 'X': STOP_K((i==BGL-1)||(*(x+i+1)<'0')||(*(x+i+1)>'9'),FT90,1);
                      STOP_K(ST==1||ST==4||ST==5,FT90,1);
                      ST=4; break;
            case '&': *(z1+j)=' '; j++; BGKL=BGKL+1;
                      STOP_K(ST!=1&&ST!=5,FT90,1);
                      ST=3; break;
            case '|': *(z1+j)=' '; *(z1+j+1)='0'; *(z1+j+2)=' ';
                      j=j+3; BGKL=BGKL+2;
                      STOP_K(ST!=1&&ST!=5,FT90,1);
                      ST=3; break;
            case '~': *(z1+j)='-'; j++;
                      STOP_K(ST!=0&&ST!=3,FT90,1);
                      ST=2; break;
            case '\\': STOP_K((i==BGL-1)||(*(x+i+1)!='n'),FT90,1);
                       break;
            default:  if   ((*(x+i)=='n')&&(*(x+i-1)=='\\')) ;
                      else {STO_SCH=1; STOP_X(FT90);} break;
           }
     }
 *(z1+j)=' ';
 STOP_K(ST!=1&&ST!=5,FT90,1);
 STOP_K(j>=KBGMAX-3,FT91,1);                              /* >= wegen ODER */
 if (STO_SCH==1)
    {plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
     y=mxGetPr(plhs[0]);                             /* Ausgang 1 ist BGK  */
     *y=FN;               /* Zur Sicherheit: Erstes Element von BGK ist FN */
     plhs[1]=mxCreateDoubleMatrix(1,1,mxREAL);
     y2=mxGetPr(plhs[1]);                            /* Ausgang 2 ist VZG  */
     *y2=0+'\0';                                             /* Keine Ikone*/
    }
 else
    {
     plhs[0]=mxCreateDoubleMatrix(1,BGKL+1,mxREAL);
     y=mxGetPr(plhs[0]);                             /* Ausgang 1 ist BGK  */
     *y=FN;                               /* Erstes Element von BGK ist FN */
     j=0; c=0;
     for (i=1; i<BGKL+1; i++)
         {c=j;
          while ((*(z1+j)!=' ')&&(j<KBGMAX-1)) j++;
          *(z1+j)='\0'; j++;
          ZS=atoi(z1+c);
          *(y+i)=ZS;
          if (abs(ZS)>BNRMAX) {STO_SCH=1;}
         }
     if (STO_SCH==1)
        {STOP_X(FT92);
         plhs[1]=mxCreateDoubleMatrix(1,1,mxREAL);
         y2=mxGetPr(plhs[1]);                        /* Ausgang 2 ist VZG  */
         *y2=0+'\0';                                         /* Keine Ikone*/
        }
     else
        {plhs[1]=mxCreateDoubleMatrix(1,20+BGL,mxREAL);
         y2=mxGetPr(plhs[1]);                        /* Ausgang 2 ist VZG  */
         *(VZG+16)=FN+48;
         for (i=0; i<20;  i++) *(y2+i)=*(VZG+i);
         for (i=0; i<BGL; i++) *(y2+i+20)=*(x+i);
        }
    }    
}
