/* Aufruf von FUPI_AZF1 in FUP Steuer-MEX-Funktion FUPI_V30 - version 3.2  */
/* [FN,FNsI]=FUPI_V30(FNu,0,60) ---> Initialisierung fr Blcke AZF        */

#define  C_MEX_FUNCTION
#include "F2_FUPLIB30.h"

void FUPI_AZF1(nlhs, nrhs, plhs, prhs)
     int            nlhs;
     int            nrhs;
     mxArray        *plhs[];
     const mxArray  *prhs[];
{
 char    *FNsI="Active States\nFUP  ";
 double  *x, *y, *y2, FN, fp;
 int     i;

 extern int STO_SCH;           /* hier eigene Instanz von STO_SCH fr FUPI */
                                                         /* Eingabeprfung */
 STOP_K((mxGetM(prhs[0])!=1)||(mxGetN(prhs[0])!=1)||
        (mxGetM(prhs[1])!=1)||(mxGetN(prhs[1])!=1)||
        (mxGetM(prhs[2])!=1)||(mxGetN(prhs[2])!=1),FT98,1);
 STOP_K(nlhs!=2,FT99,1);
 
 plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
 y=mxGetPr(plhs[0]);
 plhs[1]=mxCreateDoubleMatrix(1,19,mxREAL); /* z.Z. FN 1-stellig definiert */
 y2=mxGetPr(plhs[1]);
 x=mxGetPr(prhs[0]);
 
 modf(*x, &FN);                            /* ganze Zahl in FN schreiben   */
 fp=*x-FN;                                 /* Rest berechnen               */
 STOP_K(FN<FNRMIN||FN>FNRMAX||fp!=0,FT74,1);
 if (STO_SCH==0)
    {for (i=0; i<18; i++) {*(y2+i) =*(FNsI+i);}    /* Zhlung von Null aus */
     *(y2+18)=FN+48;      
    }
 *y=FN;
}
               