%Preliminary remark before use - dear potential user,
%
%originally this ZIP file would contain a ready for use FunctionChart block library,
%but >>>THIS<<< ZIP file version doesn't contain any dynamic link library, i.e. neither
%mexw64 nor mexw32, dll or mexhpux. Reason may be learnt from following e-mail
%after having prepared a first submission of this Simulink add-on block library:
%-------------------------------------------------------------------------------
%... thank you for participating in the MATLAB Central Community.  I have reviewed
% your submission to File Exchange and noticed it contains .DLL and .MEX files. 
%Since it's important for others to be able to inspect and learn from your code, 
%we do not publish any executable files (EXE, DLL, P- code, MEX, etc.).  Please 
%consider resubmitting your contribution without the .DLL and .MEX files.
%... MATLAB Central Administrator, MathWorks 
%-------------------------------------------------------------------------------
%Thus you cannot directly download and test. There are two possible
%workarounds:
%
%A, 
%Please look at Function Chart homepage with links for complete ZIP files:
%http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7e.htm
%Version 3.2:    this current version completely (English block icons and GUI)
%Version 1.8:    easy m-file based version (without necessity of dynamic link library 
%                generation, but strong limited functionality, no GUI check tools,
%                not ready for real-time code generation using RTW and xPC target for instance)
%obsolate version: some obsolate version (German block icons and GUI, not ready for 64 bit mcc)
%Files "FUP_V32.zip" at this homepage and "FUP_V32_MCFE.zip" here are identically except for
%deleted dynamic link libraries in zip file here.
%
%OR
%B,
%After having unpacked and copied files please go into directory "QuellenV32" and call
%script file FUP_V32_DynLinkLiBGen for generation 64 bit dynamic link libraries:
%FUPA_V30.mexw64, FUPI_V30.mexw64, FUPU_V30.mexw64
%Copy and paste into directory "BibV32". Library "Funktionsplan.slx" will call these 3 files.
%For missing dynamic link libraries of other versions, such as mexw32, dll or mexhpux
%rather make use of suggestion A,.
%[C, - Callback function call in library file including test for absence
%      of dynamic link libraries and automatic generation:
%      This possibility wasn't used with intent in order to avoid hidden actions.]
%
%Sorry for needless effort, but according e-mail above such intermediate step isn't avoidable.

disp('Start MEXW64 generation.');
mex FUPA_V30.c;
mex FUPI_V30.c;
mex FUPU_V30.c;
disp('MEXW64 generation done.');
disp('Please copy and paste 3 results into directory "BibV32".')
