/* Aufruf von FUPI_AZF1 in FUP Steuer-MEX-Funktion FUPI_V30                */
/* [FN,FNsI]=FUPI_V30(FNu,0,60) ---> Initialisierung fuer Bloecke AZF        */

#define  C_MEX_FUNCTION
#include "F2_FUPLIB30.h"

void FUPI_AZF1( int nlhs,        int nrhs,
                mxArray *plhs[], const mxArray *prhs[] )
{
 char    *FNsI="Aktive Zustaende\nFUP  ";
 double  *x, *y, *y2, FN, fp;
 int     i;

 extern int STO_SCH;           /* hier eigene Instanz von STO_SCH fuer FUPI */
                                                         /* Eingabepruefung */
 STOP_K((mxGetM(prhs[0])!=1)||(mxGetN(prhs[0])!=1)||
        (mxGetM(prhs[1])!=1)||(mxGetN(prhs[1])!=1)||
        (mxGetM(prhs[2])!=1)||(mxGetN(prhs[2])!=1),FT98,1);
 STOP_K(nlhs!=2,FT99,1);
 
 plhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
 y=mxGetPr(plhs[0]);
 plhs[1]=mxCreateDoubleMatrix(1,23,mxREAL); /* z.Z. FN 1-stellig definiert */
 y2=mxGetPr(plhs[1]);
 x=mxGetPr(prhs[0]);
 
 modf(*x, &FN);                                /* ganze Zahl in FN schreiben */
 fp=*x-FN;                     /* LINUX: nicht fp als modf-Ausgang definieren*/
 STOP_K(FN<FNRMIN||FN>FNRMAX||fp!=0,FT74,1);
 if (STO_SCH==0)
    {for (i=0; i<22; i++) {*(y2+i)=*(FNsI+i);}
     *(y2+21)=FN+48;                                 /* Zaehlung von Null aus */
    }                            /* LINUX: nicht auf *FNsI Rueckspeichern !!! */
 *y=FN;
}
