/* Aufruf von FUPI_FeZu5 in FUP Steuer-MEX-Funktion FUPI_V30                 */
/* [VFB,BNsI]=FUPI_V30([BN FN],0,35) ---> Initialisierung fuer Bloecke ZF    */

#define  C_MEX_FUNCTION
#include "F2_FUPLIB30.h"

void FUPI_FeZu5( int nlhs,        int nrhs,
                 mxArray *plhs[], const mxArray  *prhs[] )
{
 char    *BNsI="Allgemeiner Fehler\nF1 X    ";
 double  *x, *y, *y2, BN, FN, fp; 
 int     i;
 
 extern int STO_SCH;           /* hier eigene Instanz von STO_SCH fuer FUPI */
                                                         /* Eingabepruefung */
 STOP_K((mxGetM(prhs[1])!=1)||(mxGetN(prhs[1])!=1)||
        (mxGetM(prhs[2])!=1)||(mxGetN(prhs[2])!=1),FT87,1);
 STOP_K(nlhs!=2,FT88,1);
 STOP_K((mxGetM(prhs[0])!=1)||(mxGetN(prhs[0])!=2),FT89,1);
  
 plhs[0]=mxCreateDoubleMatrix(1,2,mxREAL);
 y=mxGetPr(plhs[0]);
 plhs[1]=mxCreateDoubleMatrix(1,28,mxREAL); /* z.Z. BN 4-stellig definiert */
 y2=mxGetPr(plhs[1]);
 x=mxGetPr(prhs[0]);

 modf(*x, &BN);                                /* ganze Zahl in BN schreiben */
 fp=*x-BN;                     /* LINUX: nicht fp als modf-Ausgang definieren*/
 STOP_K(BN<BNRMIN||BN>BNRMAX||fp!=0,FT73,1);
 modf(*(x+1), &FN);                            /* ganze Zahl in FN schreiben */
 fp=*(x+1)-FN;                 /* LINUX: nicht fp als modf-Ausgang definieren*/
 STOP_K(FN<FNRMIN||FN>FNRMAX||fp!=0,FT74,1);
 if (STO_SCH==0)
    {gcvt(BN,4,*(y2+23));
     for (i=0; i<23; i++) {*(y2+i)=*(BNsI+i);}
     *(y2+20)=FN+48;           /* Zaehlung von Null aus UND wrzl ein Zeichen */
    }
 *y=FN; 
 *(y+1)=10*BN+FN;
}
